/*	$Id: rdseed.h,v 1.1 1999/04/04 14:08:44 doug Exp $ 	*/

#ifndef	__rdseed_h
#define	__rdseed_h

#include    <stdio.h>
#include    <string.h>

#define	    STRINGTERM	"~"
#define	    TEMP_CHAR_LENGTH	8192
#define	    allocation_error(str)   fprintf(stderr,str)

char temp_char[TEMP_CHAR_LENGTH];   /* temp char str for blockette parsing. */

/*                 +=======================================+                 */
/*=================|       station header structures       |=================*/
/*                 +=======================================+                 */

struct			type50							/* station identifier */
{
	char		*station;						/* station call letters */
	double		latitude;						/* station latitude, -South */
	double		longitude;						/* station longitude, -West */
	double		elevation;						/* station elevation, meters */
	/*int		number_channels;*/				/* number of channels */
	/*int		number_comments;*/				/* number of comment blkts */
	int			reserved1;						/* reserved 4 byte field */
	int			reserved2;						/* reserved 3 byte field */
	char		*name;							/* site name */
	int			owner_code;						/* lookup for owner name */
	int			longword_order;					/* 4-byte word order */
	int			word_order;						/* 2-byte word order */
	char		*start;							/* start effective date */
	char		*end;							/* end effective date */
	char		*update;						/* update flag */
	char		*network_code;					/* v2.3 network code */
};

struct			type52							/* channel identifier */
{
	char		*location;						/* location id */
	char		*channel;						/* channel id */
	int			subchannel;						/* subchannel for mux */
	int			instrument_code;				/* lookup for inst id */
	char		*inst_comment;					/* instrument comment */
	int			signal_units_code;				/* lookup for signal units */
	int			calib_units_code;				/* lookup for calibration */
	double		latitude;						/* inst latitude */
	double		longitude;						/* inst longitude */
	double		elevation;						/* inst elevation */
	double		local_depth;					/* local depth */
	double		azimuth;						/* inst azimuth rel to N */
	double		dip;							/* inst dip down from horiz */
	int		format_code;						/* lookup for format code */
	int		log2drecl;							/* log2 of data record length */
	double		samplerate;						/* sample rate, Hz */
	double		clock_tolerance;				/* max clock drift tol */
	/*int		number_ch_comments;*/			/* number of channel comments */
	int			reserved1;						/* reserved 4 byte field */
	char		*channel_flag;					/* channel flags */
	char		*start;							/* start effective date */
	char		*end;							/* end effective date */
	char		*update;						/* update flag */
};

struct type50 *parse_type50 (char *);
struct type52 *parse_type52 (char *);
void free_type50();
void free_type52();
double parse_double (char **, int);
int parse_int (char **, int);
long int parse_long (char **, int);
char *parse_nchar (char **, int);
char *parse_varlstr (char **, char*);
int memncpy (char *, char *, int);

extern double seed_version;

#endif
